// commands.cpp : handles WM_COMMAND

/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#include "stdafx.h"
#include "soupe.h"
#define MAX_LOADSTRING 100


LRESULT HandleCommands(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	 int wmId, wmEvent;
    	 
	 wmId    = LOWORD(wParam); 
	 wmEvent = HIWORD(wParam); 
	 
	 // Parse the menu selections:
		switch (wmId)
		{

		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;


      case IDM_UPDATENOW:
      {
         static MSGINFO msgi;
         static DWORD dwId = 0;
         static HANDLE hThread = 0;
         DWORD dwExit;

         // check if thread already running
         if (hThread)
         {
            GetExitCodeThread(hThread, &dwExit);
            if (dwExit == STILL_ACTIVE)
            {
               Beep(300, 500);
               break;
            }
            else
            {
               // no thread running: set to zero
               hThread = 0;
            }
         } // end hThread

         // o.k., no thread running: start download
         msgi.hWnd = hWnd;
         msgi.message = WM_COMMAND;
         msgi.wParam = wParam;
         msgi.lParam = lParam;

         hThread = CreateThread(NULL, 0, UpdateThread, (LPVOID) &msgi, 0, &dwId);
         
         break;
      } //end case IDM_UPDATENOW



      case IDM_FORCEUPDATE:
      {
         // erase size of last update
         Reg_SetString(IDS_LAST_UPDATE, TEXT(" "));
         // start update
         PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_UPDATENOW,0), 0);
         break;
      }



		case IDM_OPTIONS:
         if (DialogBox(hInst, (LPCTSTR)IDD_OPTIONS, hWnd, (DLGPROC)Options) <= 0)
            return -1;
         else
            break; // return 0 -> success



      case IDM_UPDATEONRUN:
         {
            HMENU hMenu = GetMenu(hWnd);
            int iFlags;

            hMenu = GetSubMenu(hMenu, 2);
            iFlags = GetMenuState(hMenu, IDM_UPDATEONRUN, MF_BYCOMMAND);

            if ((iFlags & MF_CHECKED) == MF_CHECKED)
            {
               Reg_SetDW(IDS_UPDATE_ON_RUN, 0);
            }
            else
            {
               Reg_SetDW(IDS_UPDATE_ON_RUN, 1);
            }

            break;
         }



      case IDM_15:
      case IDM_30:
      case IDM_60:
         {
            int iInterval;
            TCHAR szDate[STRINGSIZE];

            if(wmId == IDM_15) iInterval = 15;
            if(wmId == IDM_30) iInterval = 30;
            if(wmId == IDM_60) iInterval = 60;

            SetUpdateInterval(iInterval);
            SetNextUpdate(iInterval);
            GetNextUpdateTime(szDate, STRINGSIZE);
            Status(TEXT("Nchstes Update:|"));
            Status(szDate);
            break;
         }
      
      
         
      case IDM_NEVER:
         {
            SetUpdateInterval(0);
            SetNextUpdate(0);
            Status(TEXT("Automatische Updates ausgeschaltet."));
            break;
         }


      case IDM_CUSTOMINTERVAL:
         {
            DialogBox(hInst, (LPCTSTR)IDD_UPDATE_INTERVAL, hWnd, (DLGPROC)UpdateInterval);
			   break;
         }
         
      case IDM_RUNONBOOT:
         {
            HMENU hMenu = GetMenu(hWnd);
            int iFlags;

            hMenu = GetSubMenu(hMenu, 2);
            iFlags = GetMenuState(hMenu, IDM_RUNONBOOT, MF_BYCOMMAND);

            if ((iFlags & MF_CHECKED) == MF_CHECKED)
            {
               Reg_SetDW(IDS_RUN_ON_BOOT, 0);
               SetRunOnBoot(FALSE);
            }
            else
            {
               Reg_SetDW(IDS_RUN_ON_BOOT, 1);
               SetRunOnBoot(TRUE);
            }

            break;
         }

     

      case IDM_ABOUT:
         {
            ShellExecute(hWnd, TEXT("open"), TEXT("http://soupe.dyndns.org/about.html"), NULL, NULL, SW_MAXIMIZE);
   			//DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
	   		break;
         }

      case IDM_SOUPEDL:
         {
            ShellExecute(hWnd, TEXT("open"), TEXT("http://soupe.dyndns.org/download.html"), NULL, NULL, SW_MAXIMIZE);
            break;
         }
      

      // -------------------------------------
      // section for commands from tray menu
      // -------------------------------------

      case IDM_SHOW:
         {
            if (!IsWindowVisible(hWnd))
               {
                  ShowWindow(hWnd, SW_RESTORE);
                  SetForegroundWindow(hWnd);
                  break;
               }
            else
            {
               ShowWindow(hWnd, SW_HIDE);
               break;
            }
         } // end case IDM_SHOW

		default:
			return DefWindowProc(hWnd, WM_COMMAND, wParam, lParam);
		}

	 return 0;
}


