// errors.cpp: error handling routines


/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#include "stdafx.h"
#include "soupe.h"
#define MAX_LOADSTRING 100


int Error(LPTSTR lpErr)
{
   return ErrorEx(lpErr, 0);
}

int ErrorW(LPWSTR lpwErr)
{
   LPSTR pTemp;
   BOOL bReturn;

   #ifdef UNICODE
   return ErrorEx((LPWSTR)lpwErr, 0);
   #else
   if (NOERROR == UnicodeToAnsi((LPWSTR)lpwErr, (LPSTR *)&pTemp))
   {
      bReturn = ErrorEx((LPSTR)pTemp, 0);
      free(pTemp);
   }
   else
      bReturn = FALSE;

   return bReturn;
   #endif

}


int ErrorEx(LPTSTR lpErr, LONG lArg)
{
   TCHAR szApp[STRINGSIZE];
   TCHAR szError[3*STRINGSIZE];
   HWND hWnd;

   LoadString(GetModuleHandle(NULL), IDS_APP_TITLE, (LPTSTR)szApp, sizeof(szApp)/sizeof(TCHAR));
   hWnd = FindWindow(NULL, szApp);

   if (lArg)
      StringCbPrintf(szError, sizeof(szError)/sizeof(TCHAR), lpErr, lArg);
   else
      StringCbCopy(szError, sizeof(szError)/sizeof(TCHAR), lpErr);

   return MessageBox(hWnd, szError, szApp, MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
}