// soupe.cpp : Defines the entry point for the application.


/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#include "stdafx.h"
#include "soupe.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND hList; // list view handle



int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

   _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

   
   // Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
   LoadString(hInstance, IDC_SOUPE, szWindowClass, MAX_LOADSTRING);

   // make sure there is only one instance
  	CreateMutex(NULL, TRUE, TEXT("SoupeSingleInstanceMutex"));
  	if (GetLastError() == ERROR_ALREADY_EXISTS)
   {
      Error(TEXT("Soupe wird bereits ausgefhrt"));
      return FALSE;
   }

   MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SOUPE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SOUPE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_SOUPE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   LPTSTR lpCommand;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   lpCommand = GetCommandLine( );
   if (_tcsstr(lpCommand, TEXT(" -mini")) == NULL)
      ShowWindow(hWnd, nCmdShow);
   else
      ShowWindow(hWnd, SW_SHOWMINIMIZED);

   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
	case WM_COMMAND:
	{
      return HandleCommands(hWnd, wParam, lParam);
   }

   // message crackers
   HANDLE_MSG(hWnd, WM_CREATE, Cls_OnCreate);
   HANDLE_MSG(hWnd, WM_DESTROY, Cls_OnDestroy);
   HANDLE_MSG(hWnd, WM_SIZE, Cls_OnSize);
   HANDLE_MSG(hWnd, WM_TIMER, Cls_OnTimer);


   // message handling for tray icon
  case MYWM_NOTIFYICON:
   	{
      if (wParam != UID) break;

      switch (lParam)
      	{
         case WM_LBUTTONDOWN:
         	{
            PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_SHOW,0), 0);
            break;
            }

         case WM_RBUTTONDOWN:
         	{
            HMENU	hMenu;
            HMENU hPopup;
            HMENU hSub;
            TCHAR szMenuName[STRINGSIZE];
            POINT Cursorpos;
            int i, iRes;
            static BOOL bInMenu = FALSE;
            WINDOWPLACEMENT wp;

            if (bInMenu)
               break;
            else
               bInMenu = TRUE;

            //activate main window
            SetForegroundWindow(hWnd);

            // load main menu
            hMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_SOUPE));
            if (!(hMenu)) return 0;

            // create empty popup
            hPopup = CreatePopupMenu( );
            if (!(hPopup)) return 0;

            // append main menu items
            i = 0;
            hSub = GetSubMenu(hMenu, i);
            while (hSub != NULL)
            {
               GetMenuString(hMenu, i, (LPTSTR)szMenuName, STRINGSIZE, MF_BYPOSITION);
               AppendMenu(hPopup, MF_POPUP | MF_STRING, (UINT_PTR) hSub, szMenuName);
               i++;
               hSub = GetSubMenu(hMenu, i);
            }

            // add special tray menu items
            hMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_TRAY));
            hSub = GetSubMenu(hMenu, 0);
            i = 0;
            iRes = GetMenuString(hSub, i, (LPTSTR)szMenuName, STRINGSIZE, MF_BYPOSITION);
            while (iRes != 0)
            {
               AppendMenu(hPopup, MF_STRING, GetMenuItemID(hSub, i), szMenuName);
               i++;
               iRes = GetMenuString(hSub, i, (LPTSTR)szMenuName, STRINGSIZE, MF_BYPOSITION);
            }
            
            // enable / disable maximize command
            GetWindowPlacement(hWnd, &wp);
            if (IsWindowVisible(hWnd))
            {
               EnableMenuItem(hPopup, IDM_SHOW, MF_BYCOMMAND | MF_GRAYED);
            }
            
            //show at cursor pos
            GetCursorPos(&Cursorpos);
            TrackPopupMenu(hPopup, TPM_LEFTALIGN | TPM_LEFTBUTTON,
         						Cursorpos.x, Cursorpos.y, 0,
                           hWnd, 0);

            PostMessage(hWnd, WM_NULL, 0, 0);
            DestroyMenu(hPopup);
            bInMenu = FALSE;

            break;
            }//end case WM_LBUTTONDOWN

         default: break;
         } //end switch lParam

      break;
      } //end MYWM_NOTIFYICON




   case WM_WINDOWPOSCHANGED:
   {
      RECT rc;
      if (IsWindow(hList))
      {
         GetClientRect(hWnd, &rc);
         SetWindowPos(hList,
                        0,
                        0,0,
                        rc.right-rc.left,
                        rc.bottom-rc.top,
                        SWP_NOZORDER);
      }

      return DefWindowProc(hWnd, message, wParam, lParam);
   }


   
   case WM_INITMENUPOPUP:
      {
         DWORD dwInterval;
         int iCheckit;
         int i;

         // is first item "update on run" command?
         if (GetMenuItemID((HMENU)wParam, 0) != IDM_UPDATEONRUN)
            break;

         // o.k. we're in AutoUpdate menu
         // uncheck 'em all
         i = 0;
         iCheckit = GetMenuItemID((HMENU)wParam, i);
         while (iCheckit != -1)
         {
         if (iCheckit) CheckMenuItem((HMENU)wParam,
                           iCheckit,
                           MF_BYCOMMAND | MF_UNCHECKED);
         i++;
         iCheckit = GetMenuItemID((HMENU)wParam, i);
         }


         // check UpdateOnRun if applicable
         if (Reg_GetDW(IDS_UPDATE_ON_RUN) == 1)
            CheckMenuItem((HMENU)wParam,
                           IDM_UPDATEONRUN,
                           MF_BYCOMMAND | MF_CHECKED);

         // check RunOnBoot if applicable
         if (Reg_GetDW(IDS_RUN_ON_BOOT) == 1)
            CheckMenuItem((HMENU)wParam,
                           IDM_RUNONBOOT,
                           MF_BYCOMMAND | MF_CHECKED);
         
         
         // predef timings? check item if so
         dwInterval = GetUpdateInterval( );
         switch(dwInterval)
         {
         case 0:
            iCheckit = IDM_NEVER;
            break;
         case 15:
            iCheckit = IDM_15;
            break;
         case 30:
            iCheckit = IDM_30;
            break;
         case 60:
            iCheckit = IDM_60;
            break;
         default:
            iCheckit = IDM_CUSTOMINTERVAL;
         }

         if (iCheckit != 255)
            CheckMenuItem((HMENU)wParam,
                           iCheckit,
                           MF_BYCOMMAND | MF_CHECKED);

      
         break;
      } //WM_INITPOPUPMENU


	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

