

/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#pragma once

#include "resource.h"
#include <windows.h>

// constant for visual styles
#define MANIFEST_RESOURCE_ID 2

// icon identifiers
#define UID     1

// messages
#define MYWM_NOTIFYICON WM_USER+1

// global vars
extern HINSTANCE hInst;		// current instance
extern HWND hList;
extern TCHAR szTitle[];					// The title bar text
extern TCHAR szWindowClass[];			// the main window class name

// typedefs
typedef struct _MSGINFO {
   HWND hWnd;
   UINT message;
   WPARAM wParam;
   LPARAM lParam;
} MSGINFO, *PMSGINFO;

//
// function declarations
//
// soupe.cpp
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

// status.cpp
BOOL Status(LPTSTR);
BOOL StatusW(LPWSTR);
BOOL StatusA(LPSTR);
BOOL StatusEx(LPTSTR, LONG);
BOOL ListOut(LPTSTR);

// functions.cpp
BOOL GetAppName(LPTSTR, DWORD);
LPSTR GetAppVersionStringA(void);
LPWSTR GetAppVersionStringW(void);
LPTSTR GetAppVersionStringEx(LPTSTR); // input A, W or NULL
BOOL GetLocalTimeString(LPTSTR, DWORD);
LPTSTR FileFromPath(LPTSTR);
BOOL TruncatePath(LPTSTR);
DWORD GetUpdateInterval(void);
DWORD SetUpdateInterval(DWORD);
BOOL GetNextUpdateTime(LPTSTR, DWORD);
BOOL SetNextUpdate(DWORD);
HRESULT __fastcall AnsiToUnicode(LPCSTR, LPOLESTR *);
HRESULT __fastcall UnicodeToAnsi(LPCOLESTR, LPSTR *);
BOOL AddTrailing(LPTSTR, DWORD, LPTSTR);
BOOL AddLeading(LPTSTR, DWORD, LPTSTR);
BOOL CheckDirectory(LPTSTR);
LPTSTR FindLast(LPTSTR, LPTSTR);
BOOL RestartService(LPTSTR);
BOOL SetRunOnBoot(BOOL);
BOOL GetAppPath(LPTSTR, DWORD);

// commands.cpp
LRESULT HandleCommands(HWND, WPARAM, LPARAM);

// dialogs.cpp
LRESULT CALLBACK About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK Options(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK UpdateInterval(HWND, UINT, WPARAM, LPARAM);

// registry.cpp
BOOL Reg_Init(int);
BOOL Reg_Install(void);
BOOL Reg_GetString(int, LPTSTR *); // always accesses prog key
BOOL Reg_GetStringEx(HKEY, int, int, LPTSTR *); // can access all keys under HKLM
BOOL Reg_SetDW(int, DWORD);
BOOL Reg_SetDWEx(HKEY, int, int, DWORD);
DWORD Reg_GetDW(int);
DWORD Reg_GetDWEx(HKEY, int, int);
BOOL Reg_SetStringEx(HKEY, int, int, LPTSTR);
BOOL Reg_SetString(int, LPTSTR);

// errors.cpp
int Error(LPTSTR);
int ErrorW(LPWSTR);
int ErrorEx(LPTSTR, LONG);

//web.cpp
LPTSTR WebGet(LPWSTR, BOOL);
LPVOID WebGetEx(LPWSTR, DWORD *, BOOL);
LPTSTR SaveDataToFile(LPVOID, DWORD, LPTSTR, LPTSTR);

// updatenow.cpp
DWORD WINAPI UpdateThread(LPVOID);
BOOL CheckForSoupeUpdate(LPSTR);
BOOL UpdateNow(HWND, WPARAM, LPARAM);

//messages.cpp
BOOL Cls_OnCreate(HWND, LPCREATESTRUCT);
void Cls_OnDestroy(HWND);
void Cls_OnSize(HWND, UINT, int, int);
void Cls_OnTimer(HWND, WPARAM);

// constants
#define STRINGSIZE   500
#define NO_UPDATE (LPTSTR)(0-1)
