// soupe.cpp : Defines the entry point for the application.


/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#include "stdafx.h"
#include "soupe.h"
#define MAX_LOADSTRING 100



BOOL Status(LPTSTR lpText)
{
   return ListOut(lpText);
}


BOOL StatusW(LPWSTR lpwText)
{
   LPSTR pTemp;
   BOOL bReturn;

   #ifdef UNICODE
   return ListOut((LPWSTR)lpwText);
   #else
   UnicodeToAnsi((LPWSTR)lpwText, (LPSTR *)&pTemp);
   bReturn = ListOut((LPSTR)pTemp);
   free(pTemp);
   return bReturn;
   #endif
}


BOOL StatusA(LPSTR lpText)
{
   LPWSTR pTemp;
   BOOL bReturn;

   #ifndef UNICODE
   bReturn = ListOut((LPSTR)lpText);
   pTemp = NULL;
   return bReturn;
   #else
   AnsiToUnicode((LPSTR)lpText, (LPWSTR *)&pTemp);
   bReturn = ListOut((LPSTR)pTemp);
   free(pTemp);
   return bReturn;
   #endif
}


BOOL StatusEx(LPTSTR lpText, LONG lArg)
{
   TCHAR szText[3*STRINGSIZE];

   if (lArg)
   {
      StringCbPrintf(szText, sizeof(szText)/sizeof(TCHAR), lpText, lArg);
      return ListOut(szText);
   }
   else
      return ListOut(szText);
}


// ListOut (LPTSTR)
//
//    print text to listbox status control
//
//    |  at end of line: just save, text following
//    |  at start of line: overwrite last line
//    || at start of line: append to line last printed
//
//
BOOL ListOut(LPTSTR lpText)
{
   static TCHAR szBuffer[STRINGSIZE];
   static BOOL bFirstrun = TRUE;
   static LRESULT lLast;
   LRESULT lIndex;
   TCHAR szTime[STRINGSIZE];
   LPTSTR lpMark;


   if(bFirstrun)
   {
      ZeroMemory(szBuffer, sizeof(szBuffer));
      bFirstrun = FALSE;
   }


   if(_tcslen(szBuffer) == 0) // no string in buffer: get time + copy
   {
      GetLocalTimeString((LPTSTR)szTime, STRINGSIZE);
      StringCbCopy(szBuffer, sizeof(szBuffer), (LPTSTR)szTime);
      StringCbCat(szBuffer, sizeof(szBuffer), lpText);
   }
   else // there is already a string in buffer: just append
   {
      StringCbCat(szBuffer, sizeof(szBuffer), lpText);
   }

   lpMark = _tcsstr(lpText, TEXT("|"));
   // send text only if line wrap signal not found in new text 
   if(NULL == lpMark)
   {
      lIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(LPTSTR)szBuffer);
      switch(lIndex)
      {
         case LB_ERR:
            break;
         case LB_ERRSPACE: // erase most entries if no more space
            {
               LONG l;
               for (l=0; l <= (lLast-20); l++)
               {
                  SendMessage(hList, LB_DELETESTRING, l, 0);
               }
               lLast = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(LPTSTR)szBuffer);
               break;
            }
         default:
            {
            lLast = lIndex;
            SendMessage(hList, LB_SETCURSEL, lIndex, 0);
            }

      } // end switch result of SendMessage

      //anyway: erase text in buffer
      ZeroMemory(szBuffer, sizeof(szBuffer));

   } // end if send text to listbox because there is no marker

   else // marker found
   {
      if (lpMark != lpText)
      {
         // marker found but not first char
         // don't send, just erase | that has been saved to buffer
         StringCbCopy(_tcsstr(szBuffer, TEXT("|")), 2*sizeof(TCHAR), TEXT(" "));
      }
      else
      {
         // mark is first char -> add to / replace last line in listbox
         if (0 ==_tcsstr(lpMark+sizeof(TCHAR), TEXT("|"))) // there is no other marker
         {
            // add to last line
            SendMessage(hList, LB_GETTEXT, lLast, (LPARAM) &szBuffer);
            StringCbCat(szBuffer, STRINGSIZE, lpText);
         }
         else
         {
            // overwrite last line: zero buffer, don't retrieve from listbox
            StringCbCopy(szBuffer, sizeof(szBuffer), (LPTSTR)szTime);
            StringCbCat(szBuffer, STRINGSIZE, lpMark+sizeof(TCHAR)); // skip first | when appending
            //memcpy(_tcsstr(szBuffer, TEXT("|")), TEXT(" "), sizeof(TCHAR)); // replace 1st| by space
         }
         
         // anyway: replace one |
         memcpy(_tcsstr(szBuffer, TEXT("|")), TEXT(" "), sizeof(TCHAR)); // replace 2nd | by space
         SendMessage(hList, LB_DELETESTRING, lLast, 0);
         lLast = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(LPTSTR)szBuffer);
         ZeroMemory(szBuffer, sizeof(szBuffer));
      }
   } // end if marker found 

   return TRUE;
}


BOOL GetAppName(LPTSTR lpBuf, DWORD dwSize)
{
   if (LoadString(GetModuleHandle(NULL), IDS_APP_NAME, lpBuf, dwSize))
      return TRUE;
   else
      return FALSE;
}


