// updatenow.cpp: routine for downloading ide files


/*********************************************************************
soupe - Soph** Update Extension
(c) 2004-2008 Ulf Buermeyer - ulf@buermeyer.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*********************************************************************/


#include "stdafx.h"
#include "soupe.h"
#define MAX_LOADSTRING 100

DWORD WINAPI UpdateThread(LPVOID lpVoid)
{
   MSGINFO *pmsgi;
   DWORD dwReturn = 0;

   pmsgi = (MSGINFO *)lpVoid;

   if(!UpdateNow(pmsgi->hWnd, pmsgi->wParam, pmsgi->lParam))
      dwReturn = 1;

   // check for soupe update
   CheckForSoupeUpdate(NULL);

   return dwReturn; // no error
}

// returns TRUE if update needed
BOOL CheckForSoupeUpdate(LPSTR lpNewVersion)
{
   // version check
   LPVOID lpVersion;
   LPSTR lpEnd;
   LPTSTR lpAppVersion;
   WCHAR szwVersionURL[STRINGSIZE];
   CHAR szVersion[STRINGSIZE];
   DWORD dwDown = 0;
   BOOL bRecent = TRUE;

   // check for more recent version of this prog
   if (0 == Reg_GetDW(IDS_DONT_UPDATE_SOUPE))
   {
      if (LoadStringW(GetModuleHandle(NULL), IDS_VERSION_URL, (LPWSTR)szwVersionURL, sizeof(szwVersionURL)))
      {
         lpVersion = WebGetEx((LPWSTR)szwVersionURL, &dwDown, FALSE); // no logging
         if (lpVersion)
         {  
            // lpVersion is always ANSI
            ZeroMemory(szVersion, STRINGSIZE);
            StringCbCopyA((LPSTR)szVersion, dwDown+1, (LPSTR)lpVersion);
            // end marker found? if not no output
            lpEnd = StrStr(szVersion, "#");
            if (lpEnd != NULL) 
            {
               *lpEnd = 0; // zero-term
               lpAppVersion = (LPSTR) GetAppVersionStringA( );
               Status(TEXT("Soupe Update Check:|"));
               if (0 != lstrcmpA(lpAppVersion, (LPSTR)szVersion))
               {
                  Status(TEXT("Auf der Soupe-Homepage gibt's die neue|"));
                  StatusA((LPSTR)szVersion);
                  Status(TEXT("|!"));
                  Status(TEXT("===>> Whlen Sie \"Neueste Version...\" im Men \"Info\" oder Strg + V <<==="));
                  bRecent = FALSE;
               }
               else
               {
                  Status(TEXT("Soupe ist auf dem neuesten Stand."));
               }
            }
            free(lpVersion);
            free(lpAppVersion);
         } // download succeeded
      } // version URL loaded
   } // end of if reg setting forbids soupe update check 
return (bRecent == FALSE); // TRUE is bRecent == FALSE ;-)
} // end function



// handling of the UpdateNow command
BOOL UpdateNow(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
      LPTSTR lpURL = NULL;
      LPWSTR lpwUniURL = NULL;
      LPTSTR lpSaved;
      LPTSTR lpTempPath;
      LPTSTR lpSAV;
      LPTSTR lpLastSize;
      DWORD dwSavedSize;
      TCHAR szIDE[STRINGSIZE];
      TCHAR szSAV[STRINGSIZE];
      BOOL bFound;
      HANDLE hSearch;
      WIN32_FIND_DATA fd;

      // user info
      Status(TEXT("--------------------------------------------------------------"));
      
      lpURL = NULL;
         
         if (!Reg_GetString(IDS_IDE_URL, (LPTSTR *) &lpURL))
         {
            if (0 != SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_OPTIONS,0), 0))
            {
               Error(TEXT("Update nicht mglich - falsche Einstellungen gewhlt!"));
               return FALSE;
            }
         }

         if (!lpURL)
         {
            if (!Reg_GetString(IDS_IDE_URL, (LPTSTR *) &lpURL) || (lpURL == NULL))
            {
               Error(TEXT("Update nicht mglich - falsche Einstellungen gewhlt!"));
               return FALSE;
            }
         }
         
         // assure unicode URL+path
         #ifdef UNICODE
         lpwUniURL = lpURL;
         #else
         AnsiToUnicode(lpURL, &lpwUniURL);
         #endif
         
         // actually load from web
         lpSaved = WebGet(lpwUniURL, TRUE); //TRUE: do log status messages

         // free mem
         free(lpwUniURL);
         #ifndef UNICODE
         free(lpURL);
         #endif

         // error?
         if (!lpSaved)
         {
            Status(TEXT("Update fehlgeschlagen."));
            return FALSE;
         }

         // size on server identical -> no update needed
         if (lpSaved == NO_UPDATE)
         {
            Status(TEXT("Kein Update ntig."));
            return FALSE;
         }

         // update succeeded
         // get temp dir from full path of saved file
         // prepare buffer
         dwSavedSize = (DWORD) _tcslen((LPTSTR)lpSaved);
         lpTempPath = (LPTSTR) malloc(dwSavedSize);
         if(!lpTempPath)
         {
            Status(TEXT("Speichermangel: Update fehlgeschlagen."));
            if (lpSaved) free(lpSaved);
            return FALSE;
         }

         // copy full path
         StringCbCopy(lpTempPath, dwSavedSize, lpSaved);

         if (!TruncatePath(lpTempPath))
         {
            Status(TEXT("Ungltiger Speicherort: Update fehlgeschlagen."));
            if (lpSaved) free(lpSaved);
            if (lpTempPath) free(lpTempPath);
            return FALSE;
         }

         // set as current dir
         SetCurrentDirectory(lpTempPath);

         // prepare file mask for IDEs in Temp
         // used in del & later in move
         StringCbCopy((LPTSTR)szIDE, STRINGSIZE, lpTempPath);
         StringCbCat((LPTSTR)szIDE, STRINGSIZE, TEXT("*.ide"));
         
         // clean temp dir
         bFound = FALSE;
         hSearch = FindFirstFile(szIDE, &fd);
         if (hSearch != INVALID_HANDLE_VALUE)
         {
            bFound = TRUE;
            Status(TEXT("Lsche alte IDEs aus dem Temp-Ordner."));
            while(bFound)
            {
               DeleteFile(fd.cFileName);
               bFound = FindNextFile(hSearch, &fd);
            } // end while
         } //end if handle valid 
         else
         {
            DWORD dwErr = GetLastError( );
            if (dwErr != ERROR_FILE_NOT_FOUND)
            {
               StatusEx(TEXT("Kann alte IDEs nicht lschen: Fehler %u"), dwErr);
               if(lpTempPath) free(lpTempPath);
               if (lpSaved) free(lpSaved);
               return FALSE;
            } // cleansing failed
         Status(TEXT("Keine alten IDEs aus dem Temp-Ordner zu lschen."));
         } // no file to del found

         // delete finished: close find
         FindClose(hSearch);

         // unpack downloaded IDE collection
         Status(TEXT("Auspacken der IDEs...|"));
         if (_tcsstr(lpSaved, TEXT(".exe")) || _tcsstr(lpSaved, TEXT(".EXE")))
         {
            // is exe file
            // prepare CreateProcess
            PROCESS_INFORMATION pi;
            SECURITY_ATTRIBUTES sa;
            STARTUPINFO si;

            ZeroMemory(&pi, sizeof(pi));
            ZeroMemory(&si, sizeof(si));
            ZeroMemory(&sa, sizeof(sa));

            // security attributes
            sa.nLength = sizeof(SECURITY_ATTRIBUTES);
            sa.lpSecurityDescriptor = NULL;
            sa.bInheritHandle = TRUE;

            // startupinfo
            si.cb = sizeof(si);
	         si.wShowWindow = SW_SHOWMINIMIZED;
            si.dwFlags = STARTF_USESHOWWINDOW;

            if (!CreateProcess(
            lpSaved,	// pointer to name of executable module
	         NULL,	// pointer to command line string
            NULL,	// pointer to process security attributes
            NULL,	// pointer to thread security attributes
            FALSE,	// handle inheritance flag
            CREATE_NEW_CONSOLE,	// creation flags
            NULL,	// pointer to new environment block
            NULL,	// pointer to current directory name
	         &si,	// pointer to STARTUPINFO
            &pi // pointer to PROCESS_INFORMATION
            ))
   	      {
               Status(TEXT("fehlgeschlagen: EXE nicht ausfhrbar."));
               if (lpTempPath) free(lpTempPath);
               if (lpSaved) free(lpSaved);
               return FALSE;
            }

            if(WaitForSingleObject(pi.hProcess, INFINITE) == WAIT_FAILED)
            {
               Status(TEXT("fehlgeschlagen (wait for EXE)."));
               if (lpTempPath) free(lpTempPath);
               if (lpSaved) free(lpSaved);
               return FALSE;
            }

            CloseHandle( pi.hProcess );
            CloseHandle( pi.hThread );

            // all's fine
            Status(TEXT("erfolgreich (EXE)."));
         } // end if exe file
         else
         {
            Status(TEXT("fehlgeschlagen: unbekanntes Datenformat."));
            if (lpTempPath) free(lpTempPath);
            if (lpSaved) free(lpSaved);
            return FALSE;
         }

   // finished treating file just saved: free mem for path
   if (lpSaved) free(lpSaved);

   // now move IDEs to SAV dir
   // get path to sav
   if (!Reg_GetString(IDS_SAV_PATH, (LPTSTR *) &lpSAV))
   {
      Error(TEXT("Kein gltiger Ordner fr den Virenscanner eingestellt!"));
      PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_OPTIONS,0), 0);
      return FALSE;
   }
   
   // copy to buffer & add backslash if necessary
   StringCbCopy(szSAV, STRINGSIZE, lpSAV);
   if (lpSAV) free(lpSAV);

   AddTrailing(szSAV, STRINGSIZE, TEXT("\\"));

   // actually move
   bFound = FALSE;
   hSearch = FindFirstFile(szIDE, &fd);
      if (hSearch != INVALID_HANDLE_VALUE)
         {
            LPTSTR lpNewName;
            TCHAR szNewPath[STRINGSIZE];
            TCHAR szOldPath[STRINGSIZE];
            
            bFound = TRUE;
            Status(TEXT("Kopiere IDEs aus dem Temp-Ordner in den Ordner des Virenscanners."));
            while(bFound)
            {
               lpNewName = FileFromPath(fd.cFileName);
               Status(TEXT("Kopiere|"));
               Status(lpNewName);
               StringCbCopy(szNewPath, STRINGSIZE, szSAV);
               StringCbCat(szNewPath, STRINGSIZE, lpNewName);
               StringCbCopy(szOldPath, STRINGSIZE, lpTempPath);
               StringCbCat(szOldPath, STRINGSIZE, lpNewName);
               MoveFileEx(szOldPath, szNewPath, MOVEFILE_REPLACE_EXISTING);
               bFound = FindNextFile(hSearch, &fd);
            } // end while
         } //end if handle valid 
         else
         {
            DWORD dwErr = GetLastError( );
            if (dwErr != ERROR_FILE_NOT_FOUND)
            {
               StatusEx(TEXT("Kopieren nicht mglich: Fehler %u"), dwErr);
               if(lpTempPath) free(lpTempPath);
               return FALSE;
            } // cleansing failed
         Status(TEXT("Keine IDEs im Temp-Ordner gefunden."));
         if (lpTempPath) free(lpTempPath);
         return FALSE;
         } // no file to del found
         FindClose(hSearch);
   
   // updated: restart SAV service
   Status(TEXT("Kopieren erfolgreich"));
   Status(TEXT("Neustart des Antivirus-Service..."));

   if(!RestartService(TEXT("sweepsrv.sys")))
   {
      Status(TEXT("Neustart des Antivirus-Service fehlgeschlagen;|"));
      Status(TEXT("das Antivirus-Update ist daher noch nicht wirksam."));
      Status(TEXT("Versuchen Sie einen manuellen Neustart oder starten Sie den Rechner neu."));
      if (lpTempPath) free(lpTempPath);
      return FALSE;
   }

   Status(TEXT("erfolgreich neu gestartet - Virenschutz ist up-to-date :-)"));

   // copy DL size to size of last successful update
   if (Reg_GetString(IDS_LAST_DL, (LPTSTR *) &lpLastSize))
   {
      Reg_SetString(IDS_LAST_UPDATE, (LPTSTR) lpLastSize);
      free(lpLastSize);
   }

   if (lpTempPath) free(lpTempPath);

   return TRUE;
}
