// web.cpp: downloading any file using winhttp.dll
//

#include "stdafx.h"
#include "soupe.h"
#include <winhttp.h>
#define MAX_LOADSTRING 100
#define BLOCKSIZE 500


LPTSTR WebGet(LPWSTR lpwURL, BOOL bLog)
{
   LPTSTR lpSavedFile;
   LPTSTR lpPath;
   LPVOID lpData;
   LPWSTR pTemp = NULL;
   LPWSTR pFile = NULL;
   LPTSTR lpFile = NULL;
   DWORD dwDown;

   // get file name out of cracked URL
   // (these strings are always in unicode)
   pTemp = lpwURL;
   do
   {
      pFile = wcschr((LPWSTR)pTemp, (WCHAR)'/');
      if (pFile) pTemp = pFile+1;
   } while(pFile);

   pFile = (LPWSTR)pTemp;

   // erase : + Port
   pTemp = wcschr(pFile, (WCHAR)':');
   if (pTemp != NULL)
      *(pTemp) = 0;

   UnicodeToAnsi(pFile, (LPSTR *) &lpFile);
     
   // get path to save file in and save data there or in temp file path
   if (Reg_GetString(IDS_TEMP_PATH, (LPTSTR *) &lpPath))
   {
      lpData = WebGetEx(lpwURL, &dwDown, bLog);
      if ((lpData == NO_UPDATE) || (lpData == NULL))
      {
         free(lpPath);
         free(lpFile);
         return (LPTSTR) lpData;
      }
      lpSavedFile = SaveDataToFile(lpData, dwDown, lpPath, lpFile);
      free(lpData);
      free(lpFile);
      free(lpPath);
      return lpSavedFile;
   }
   else
   {
      lpData = WebGetEx(lpwURL, &dwDown, bLog);
      lpSavedFile = SaveDataToFile(lpData, dwDown, NULL, NULL);
      free(lpData);
      return lpSavedFile;
   }

return NULL;
}



// load file from web
// pdwSize: pointer to DWORD to store num of bytes read
// bLog: flag for logging on / off
// return value: pointer to mem block containing data read
LPVOID WebGetEx(LPWSTR lpwURL, DWORD *pdwSize, BOOL bLog)
{
   // web access
   DWORD dwSize = 0;
   DWORD dwDownloaded = 0;
   DWORD dwStored = 0;
   DWORD dwStorage = 0;
   DWORD dwSizeOnServer = 0;
   DWORD dwPart = 0;
   DWORD dwLastUpdateSize = 0;
   LPVOID pOutBuffer = NULL;
   LPVOID pOut = NULL;
   LPVOID pTemp = NULL;
   LPTSTR lpLastSize;
   LPWSTR lpwVersion;
   LPWSTR pFile = NULL;
   BOOL  bResults = FALSE;
   HINTERNET  hSession = NULL, 
              hConnect = NULL,
              hRequest = NULL;

   //always UNICODE for WinHTTP parameters
   URL_COMPONENTS url;
   WCHAR szwHost[STRINGSIZE];
   WCHAR szwPath[STRINGSIZE];
   WCHAR szwIdent[STRINGSIZE];
   WCHAR szwHeader[STRINGSIZE];


   // crack URL: prerequisites
   ZeroMemory(&url, sizeof(url));
   url.dwStructSize = sizeof(url);
   url.lpszHostName = (LPWSTR) szwHost;
   url.dwHostNameLength = STRINGSIZE;
   url.lpszUrlPath = (LPWSTR) szwPath;
   url.dwUrlPathLength = STRINGSIZE;
      
   // info for user
   if (bLog) Status(TEXT("Starte Download von|"));
   if (bLog) StatusW((LPWSTR)lpwURL);
   
   // crack URL
   if (!WinHttpCrackUrl(lpwURL, (DWORD)wcslen(lpwURL), 0, &url))
   {
      if (bLog) ErrorEx( TEXT("Ungltige URL - Fehler %d."), GetLastError( ));
      return NULL;
   }

   // build app name - always unicope
   if (!LoadStringW(GetModuleHandle(NULL), IDS_APP_NAME, szwIdent, STRINGSIZE))
   {
      if (bLog) Status(TEXT("Kein Zugriff auf den Programmnamen"));
      return NULL;
   }

   // add space + version
   lpwVersion = (LPWSTR) GetAppVersionStringW( );
   if(lpwVersion)
   {
      StringCbCatW(szwIdent, STRINGSIZE, L" ");
      StringCbCatW(szwIdent, STRINGSIZE, lpwVersion);
/*
   #ifdef UNICODE
      StringCbCatW(szwIdent, STRINGSIZE, lpVersion);
   #else
      AnsiToUnicode(lpVersion, (LPWSTR *)&lpwVersion);
      StringCbCatW(szwIdent, STRINGSIZE, lpwVersion);
      free(lpwVersion);
   #endif
*/

      free(lpwVersion);
   }

   // Use WinHttpOpen to obtain a session handle.
   hSession = WinHttpOpen( szwIdent,
                          WINHTTP_ACCESS_TYPE_DEFAULT_PROXY,
                          WINHTTP_NO_PROXY_NAME, 
                          WINHTTP_NO_PROXY_BYPASS, 0 );
   if(!hSession)
   {
      if (bLog) StatusEx( TEXT("Fehler %d in HTTPOpen."), GetLastError( ));
      return NULL;
   }


   // Specify an HTTP server.
   hConnect = WinHttpConnect( hSession, (LPWSTR)szwHost,
                               url.nPort, 0 );
   if( !hConnect )
   {
      if (bLog) StatusEx( TEXT("Verbindung fehlgeschlagen - Fehler %d."), GetLastError( ));
      return NULL;
   }


   // Create an HTTP request handle.
   hRequest = WinHttpOpenRequest( hConnect, L"GET", (LPWSTR)szwPath,
                                   NULL, WINHTTP_NO_REFERER, 
                                   WINHTTP_DEFAULT_ACCEPT_TYPES, 
                                   WINHTTP_FLAG_REFRESH); //WINHTTP_FLAG_SECURE );
   if(!hRequest )
   {
      if (bLog) StatusEx( TEXT("Fehler %d in HTTPOpenRequest."), GetLastError( ));
      // Close any open handles.
      if( hConnect ) WinHttpCloseHandle( hConnect );
      if( hSession ) WinHttpCloseHandle( hSession );
      return NULL;
   }

   // Send a request.
   if (bLog) Status(TEXT("Verbinden mit dem Server...|"));
   bResults = WinHttpSendRequest( hRequest,
                                 WINHTTP_NO_ADDITIONAL_HEADERS, 0,
                                 WINHTTP_NO_REQUEST_DATA, 0, 
                                 0, 0 );
   if(!bResults)
   {
      if (bLog) Status(TEXT("Verbindung nicht mglich."));
      // Close any open handles.
      if( hRequest ) WinHttpCloseHandle( hRequest );
      if( hConnect ) WinHttpCloseHandle( hConnect );
      if( hSession ) WinHttpCloseHandle( hSession );
      return NULL;
   }
  
  // End the request.
  bResults = WinHttpReceiveResponse( hRequest, NULL );
  if(!bResults)
  {
     if (bLog) Status(TEXT("Verbindung nicht mglich."));
     // Close any open handles.
     if( hRequest ) WinHttpCloseHandle( hRequest );
     if( hConnect ) WinHttpCloseHandle( hConnect );
     if( hSession ) WinHttpCloseHandle( hSession );
     return NULL;
  }

  // some status info
  if (bLog) Status(TEXT("Verbunden."));
  if (bLog) Status(TEXT("Sende Anfrage nach Datei...|"));

  // check HTTP status code
  dwSize = STRINGSIZE;
  bResults = WinHttpQueryHeaders(  hRequest, 
                        WINHTTP_QUERY_STATUS_CODE,
                        WINHTTP_HEADER_NAME_BY_INDEX,
                        (LPVOID) szwHeader,
                        &dwSize,
                        WINHTTP_NO_HEADER_INDEX);

   if (bLog) Status(TEXT("Server antwortet mit HTTP-Status:|"));
   if (bLog) StatusW(szwHeader);

   if (0 != wcsstr(L"404", szwHeader))
   {
      if (bLog) Status(TEXT("Datei nicht gefunden!"));
      // Close any open handles.
      if( hRequest ) WinHttpCloseHandle( hRequest );
      if( hConnect ) WinHttpCloseHandle( hConnect );
      if( hSession ) WinHttpCloseHandle( hSession );
      return NULL;
   }
   if (0 == wcsstr(L"200", szwHeader))
   {
      if (bLog) Status(TEXT("Webserver verweigert den Zugriff!"));
      // Close any open handles.
      if( hRequest ) WinHttpCloseHandle( hRequest );
      if( hConnect ) WinHttpCloseHandle( hConnect );
      if( hSession ) WinHttpCloseHandle( hSession );
      return NULL;
   }

   // check file size on server
   dwSize = STRINGSIZE;
   bResults = WinHttpQueryHeaders( hRequest, 
                        WINHTTP_QUERY_CONTENT_LENGTH ,
                        WINHTTP_HEADER_NAME_BY_INDEX,
                        (LPVOID) szwHeader,
                        &dwSize,
                        WINHTTP_NO_HEADER_INDEX);
   if (bLog) Status(TEXT("Gre der Datei:|"));
   if (bLog) StatusW(szwHeader);
   if (bLog) Status(TEXT("|bytes."));

   dwSizeOnServer = wcstoul(szwHeader, 0, 10);

   // compare with last saved size
   if (Reg_GetString(IDS_LAST_UPDATE, (LPTSTR *) &lpLastSize))
   {
      dwLastUpdateSize = _tcstoul(lpLastSize, 0, 10);
      free(lpLastSize);
      if (dwLastUpdateSize == dwSizeOnServer)
      {
         if (bLog) Status(TEXT("IDE-Datei hat dieselbe Gre wie beim letzten Update."));
         // Close any open handles.
         if( hRequest ) WinHttpCloseHandle( hRequest );
         if( hConnect ) WinHttpCloseHandle( hConnect );
         if( hSession ) WinHttpCloseHandle( hSession );
         return NO_UPDATE;
      }
   }

   // size not identical: go on
   // alloc buffer for results
   pOut = malloc(dwSizeOnServer);
   if (!pOut)
   {
      if (bLog) Status( TEXT("Out of memory!"));
      return FALSE;
   }

   ZeroMemory(pOut, dwSizeOnServer);
   dwStorage = dwSizeOnServer;

   // insert dummy line to be overwritten
   if (bLog) Status(TEXT("Lade..."));

   // Keep checking for data until there is nothing left.
   if( bResults )
   {
      do 
      {
      // Check for available data.
      dwSize = 0;
      if( !WinHttpQueryDataAvailable( hRequest, &dwSize ) )
      {
         if (bLog) StatusEx( TEXT("Fehler %u in WinHttpQueryDataAvailable.\n"), GetLastError( ) );
      }

      // Allocate space for the buffer.
      pOutBuffer = malloc (dwSize+1);
      if( !pOutBuffer )
      {
         Error( TEXT("Out of memory\n") );
         dwSize=0;
      }
      else
      {
         // Read the data.
         ZeroMemory( pOutBuffer, dwSize+1 );

         if( !WinHttpReadData( hRequest, pOutBuffer, 
                              dwSize, &dwDownloaded ) )
         {
            if (bLog) StatusEx( TEXT("Fehler %u in WinHttpReadData.\n"), GetLastError( ) );
         }
         else
         {
            if(dwStored + dwDownloaded > dwStorage)
            {
               // not enough space left in buffer: alloc new, copy data
               if (dwStorage + BLOCKSIZE < dwStored+dwDownloaded)
                  dwStorage += dwDownloaded;
               else
                  dwStorage += BLOCKSIZE;
               pTemp = malloc(dwStorage);
               if (!pTemp)
               {
                  if(bLog) Status(TEXT("Out of memory!"));
                  free(pOutBuffer);
                  return FALSE;
               }
               ZeroMemory(pTemp, dwStorage);
               memcpy(pTemp, pOut, dwStored);
               free(pOut);
               pOut = pTemp;
            }
            // anyway: store & display progress
            memcpy(((LPBYTE)pOut)+dwStored, pOutBuffer, dwDownloaded);
            dwStored += dwDownloaded;
            dwPart = (DWORD) ((dwStored*100)/dwSizeOnServer);
            if (dwPart == 0) dwPart = 1;
            if (bLog) StatusEx(TEXT("||%u bytes ="), dwStored);
            if (bLog) StatusEx(TEXT("|%u Prozent gelesen."), dwPart);
        }

        // Free the memory allocated to the buffer.
        if (pOutBuffer)
        {
           free(pOutBuffer);
           pOutBuffer = NULL;
        }
      } // else -> data read & buffer allocated
    } while( dwSize > 0 );
  }

  // Report any errors.
  if( !bResults )
    if (bLog) StatusEx( TEXT("Fehler %d beim Lesen vom HTTP-Server.\n"), GetLastError( ) );

  // Close any open handles.
  if( hRequest ) WinHttpCloseHandle( hRequest );
  if( hConnect ) WinHttpCloseHandle( hConnect );
  if( hSession ) WinHttpCloseHandle( hSession );

   if (!pOut)
      return NULL;
   
   if(_tcslen((LPTSTR)pOut) < 2)
   {
      if (bLog) Status(TEXT("Keine Daten zum Herunterladen gefunden."));
      free(pOut);
      return NULL;
   }
   
   if (dwStored != dwSizeOnServer)
   {
      if (bLog) Status(TEXT("Konnte nicht die gesamte Datei laden."));
      return NULL;
   }

   // -------------- download finished ------------------------

   if (bLog) Status(TEXT("Herunterladen erfolgreich."));

   // save server size of this DL as last DL size (intermediate)
   // first: convert to proper string format
   StringCbPrintf((LPTSTR)szwHeader, STRINGSIZE, TEXT("%u"), dwSizeOnServer);
   // save
   Reg_SetString(IDS_LAST_DL, (LPTSTR) szwHeader);

   *pdwSize = dwStored;
   return pOut;
   }



// lpPath and / or lpFile may be null -> temp file will be used
// return value: LPTSTR to full path of file saved to

LPTSTR SaveDataToFile(LPVOID pOut, DWORD dwSize, LPTSTR lpPath, LPTSTR lpFile)
{
   TCHAR szTempPath[STRINGSIZE];
   TCHAR szTempFile[STRINGSIZE];
   HANDLE hTempFile = NULL;
   DWORD dwBytesWritten = 0;
  

   // first step: path to save in
   if (!lpPath)
   {
      GetTempPath(STRINGSIZE, (LPTSTR)szTempPath);
   }
   else
   {
      StringCbCopy((LPTSTR)szTempPath, STRINGSIZE, lpPath);
   }

   // make sure path ends in backslash & directory exists
   AddTrailing((LPTSTR) szTempPath, STRINGSIZE, TEXT("\\"));

   if (!CheckDirectory((LPTSTR) szTempPath))
   {
      Error(TEXT("Das angegebene Download-Verzeichnis ist ungltig und kann auch nicht erzeugt werden!"));
      PostMessage(FindWindow(NULL, szTitle), WM_COMMAND, MAKEWPARAM(IDM_OPTIONS,0), 0);
      free(pOut);
      return NULL;
   }

   // get temp file name or combine it out of supplied data
   if (lpFile == NULL)
   {
      GetTempFileName((LPTSTR)szTempPath, // dir. for temp. files
         TEXT("idefile"),                // temp. file name prefix
         0,                            // create unique name
         (LPTSTR)szTempFile);          // buffer for name 
   }
   else
   {
   // to be open for future mods keep distinct vars for path and FQFN
   StringCbCopy((LPTSTR)szTempFile, STRINGSIZE, (LPTSTR)szTempPath);
   StringCbCat((LPTSTR)szTempFile, STRINGSIZE, (LPTSTR)lpFile);
   }


   // info
   Status(TEXT("Speichere heruntergeladene Datei als|"));
   Status((LPTSTR)szTempFile);

   // create file
   hTempFile = CreateFile((LPTSTR) szTempFile,  // file name
      GENERIC_READ | GENERIC_WRITE, // open for read/write
      0,                            // do not share
      NULL,                         // no security
      CREATE_ALWAYS,                // overwrite existing file
      FILE_ATTRIBUTE_TEMPORARY,
      NULL);


   if (hTempFile == INVALID_HANDLE_VALUE)
   {
	   ErrorEx(TEXT("Error %u getting temp file!"), GetLastError( ));
      if(pOut) free(pOut);
	   return FALSE;
   }


   if (!WriteFile(hTempFile, pOut, dwSize,
      &dwBytesWritten, NULL))
      {
		   ErrorEx(TEXT("Fehler %u beim Speichern"), GetLastError( ));
         if(pOut) free(pOut);
			return NULL;
      }

   CloseHandle(hTempFile);

   Status(TEXT("Erfolgreich gespeichert."));

   // return full path to saved file
   pOut = malloc(_tcslen((LPTSTR)szTempFile)+1);
   if (pOut)
      StringCbCopy((LPTSTR)pOut, _tcslen((LPTSTR)szTempFile)+1, (LPTSTR) szTempFile);

return (LPTSTR) pOut;
}
